# UKUI-KWin

UKUI-KWin is an easy to use, but flexible, composited Window Manager for Xorg windowing systems (Wayland, X11) on Linux. Its primary usage is in conjunction with a Desktop Shell (e.g. UKUI). UKUI-KWin is designed to go out of the way; users should not notice that they use a window manager at all. Nevertheless UKUI-KWin provides a steep learning curve for advanced features, which are available, if they do not conflict with the primary mission. UKUI-KWin does not have a dedicated targeted user group, but follows the targeted user group of the Desktop Shell using UKUI-KWin as it's window manager.

## UKUI-KWin is not...

 * a standalone window manager (c.f. openbox, i3) and does not provide any functionality belonging to a Desktop Shell.
 * a replacement for window managers designed for use with a specific Desktop Shell (e.g. GNOME Shell)
 * a minimalistic window manager
 * designed for use without compositing or for X11 network transparency, though both are possible.

# Contributing to UKUI-KWin

Please refer to the [contributing document](CONTRIBUTING.md) for everything you need to know to get started contributing to UKUI-KWin.

# Contacting UKUI-KWin development team

 * mailing list: [ukui@lists.openkylin.top](https://mailweb.openkylin.top/postorius/lists/ukui.lists.openkylin.top/)
 * WeChat Group: Conact openkylin assistant

# Support
## Application Developer
If you are an application developer having questions regarding windowing systems (either X11 or Wayland) please do not hesitate to contact us. Preferable through our mailing list. Ideally subscribe to the mailing list, so that your mail doesn't get stuck in the moderation queue.

## End user
Please contact the support channels of your Linux distribution for user support. The UKUI-KWin development team does not provide end user support.

## Guidelines for new features

A new Feature can only be added to UKUI-KWin if:

 * it does not violate the primary missions as stated at the start of this document
 * it does not introduce instabilities
 * it is maintained, that is bugs are fixed in a timely manner (second next minor release) if it is not a corner case.
 * it works together with all existing features
 * it supports both single and multi screen (xrandr)
 * it adds a significant advantage
 * it is feature complete, that is supports at least all useful features from competitive implementations
 * it is not a special case for a small user group
 * it does not increase code complexity significantly
 * it does not affect UKUI-KWin's license (GPLv2+)

All new added features are under probation, that is if any of the non-functional requirements as listed above do not hold true in the next two feature releases, the added feature will be removed again.

The same non functional requirements hold true for any kind of plugins (effects, scripts, etc.). It is suggested to use scripted plugins and distribute them separately.
